# booleans
print bool
# numbers
print 1
print 1 + 2
print 2**64
print 1.0 + 2.0
print (2.0 + 1.0j) * (2 - 1j)
print type(1), type(1L), type(2**64), type(2.0), type(2+1j)
# strings
print "double quoted"
print 'single quoted'
print "handy for 'quotes' in strings"
print "escape characters \t tab \n newline \\ backslash"
print """multiline
strings
"""
print r"raw strings \texcommand"
# tuples
x = (1, 2)
y = (3,)   # need extra comman
z = x + y
print x[1]
print z
x[0] = 7
print ()
print len(z)
v = ((1,2), "b", 6)
# lists
x = [1, 2]
y = [3]
z = x + y
print len(z)
z[1] = 7
z.append("q")
z.sort()
print sorted(x)
# dictionaries
d = { "a":2, 5: "q" }
print d["a"]
d[(1,2)] = 9
print len(d)
# sets
s = set()
t = set([2, 3, 3])
print t
t.add("b")
# multidimensional arrays
from numpy import *
a = array([[1, 2], [9, 8]])
z = zeros((3, 4))
p = ones((2, 5, 3))
q = p[1,:,2]
q[1:-1] = 6
print p
x = arange(8)
print x[1::2]
A = identity(8) + random.normal(0.0, 0.1, (8, 8))
print dot(A, x)
a = reshape(arange(4*7), (4, 7))
print a
b = a[1:2, :]
b[:,:] = b * 2
print a
print a[0,1:6:2]
# functions
def f(x, y):
    return x + y**2
b = [ (f, "a function") ]
def adder(x):
    def add(y):
        return x + y
    return add
add5 = adder(5)
print add5(6)
# classes
class c:
    def __init__(self, x):
        self.x = x
    def show(self):
        print self.x
# instances
o = c(4)
o.show()
# modules
import string
print string.lowercase
from numpy.linalg import eigvals
print eigvals(A)
# exceptions
try:
    file = open("/tmp/blabla.txt", "r")
except IOError, e:
    print "Couldn't open file"
    print e
# iterators, generators
class squares:
    def __init__(self, data):
        self.data = data
        self.index = 0
    def __iter__(self):
        return self
    def next(self):
        if self.index < len(self.data):
            x = self.data[self.index]
            self.index += 1
            return x * x
        else:
            raise StopIteration
sqs = squares([1, 3, 5, 7])
for x in sqs:
    print x

def square_gen(data):
    for x in data:
        yield x * x
for x in square_gen([1, 3, 5, 7]):
    print x

# getting help
import numpy
print str(numpy)
print type(numpy)
print type(1)
print type({})
help({})
print dir({})
print [ name for name in dir(numpy) if name[0] == "d" ]
print [ name for name in dir(numpy) if "max" in name ]
import util
print util.print_dir_by_type(numpy)
