from numpy import *
from pyx import *

from quad_test import *
from trap import trap_quad
from double_exponential import de_quad
from gauss import gauss_legendre_formula

#f = semicirc
#f = sinus100
f = expsin
#f = flatends
#f = f5

Ns = [ 2*i+1 for i in range(1, 20) ]
err = []
for N in Ns:
    I = [ None ] * 3
    n = N - 1
    I[0] = trap_quad(f, f.low+1e-16, f.high-1e-16, n)
    n = (N - 1)/2
    I[1] = de_quad(f, f.low, f.high, 3.0/n, n)
    n = N
    gl = gauss_legendre_formula(n)
    I[2] = gl.integrate(f, f.low, f.high)
    err.append([abs(i - f.exact) for i in I])

plotdata = zeros((len(Ns), 4))
plotdata[:,0] = Ns
plotdata[:,1:] = array(err) + 1e-18
label = [ "TR", "DE", "GL" ]
g = graph.graphxy(width=8, y=graph.axis.log(), 
                  key=graph.key.key(pos="bl"))
g.plot([ graph.data.points(plotdata, x=1, y=i+2, title=label[i]) 
         for i in range(3) ])
g.writetofile("quad_compare.eps")

