from numpy import *

def f0(t):
    return 1.0
f0.low = -1.0
f0.high = 1.0
f0.exact = 2.0

def f1(t):
    return t * log(1+t)
f1.low = 0.0
f1.high = 1.0
f1.exact = 1.0/4.0

def f5(t):
    return sqrt(t) * log(t)
f5.low = 0.0
f5.high = 1.0
f5.exact = -4.0/9.0

def f6(t):
    return sqrt(1.0 - t**2)
f6.low = 0.0
f6.high = 1.0
f6.exact = pi/4.0

def semicirc(t):
    return sqrt(1.0 - t**2)
semicirc.low = -1.0
semicirc.high = 1.0
semicirc.exact = pi/2.0

def sinus(t):
    return sin(pi*t)
sinus.low = -1.0
sinus.high = 1.0
sinus.exact = 0.0

def sinus100(t):
    return sin(100*pi*t)
sinus100.low = -1.0
sinus100.high = 1.0
sinus100.exact = 0.0

def expsin(t):
    return exp(sin(pi*t))
expsin.low = -1.0
expsin.high = 1.0
n = 2000
#expsin.exact = 2.5321317555039395
y = expsin(-1.0 + 2.0*arange(n)/n)
y.sort()
expsin.exact = sum(y)*2.0/n

def flatends(t):
    ind = nonzero(greater_equal(absolute(t), 1.0))
    t = array(t, copy=1)
    put(t, ind, 0.0)
    y = exp(-1/(1-t**2))
    put(y, ind, 0.0)
    return y
flatends.low = -1.0
flatends.high = 1.0
n = 1000
flatends.exact = sum(flatends(-1.0 + 2.0*arange(n+1)/n))*2.0/n

