# multigrid_task_run.py
from numpy import *
import multigrid_task

# 1D test
n = 2**8
dx = 1.0 / n
x = arange(n+1) * dx
u_exact = x**2
f  = -2 + 0*x
g = u_exact.copy()
g[1:-1] = 0.0
u = multigrid_task.solve_1d(g, f) 
print abs(u - u_exact).max()

# 2D test
nx, ny = 2**8, 2**8
dx, dy = 1.0 / nx, 1.0 / ny
ix, iy = mgrid[:nx+1,:ny+1] 
x, y = dx * ix, dy * iy
u_exact = x**2 + y**2
f  = -4 + 0*x  + 0*y
g = u_exact.copy()
g[1:-1,1:-1] = 0.0
u = multigrid_task.solve_2d(g, f) 
print abs(u - u_exact).max()
